ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.20
Committed: Sat Jun 4 00:33:53 2011 UTC (12 years, 10 months ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.19: +8 -3 lines
Log Message:
Added comment with execution arguments

File Contents

# User Rev Content
1 greg 2.1 #!/usr/bin/perl -w
2 greg 2.20 # RCSid $Id: genBSDF.pl,v 2.19 2011/06/03 19:41:14 greg Exp $
3 greg 2.1 #
4     # Compute BSDF based on geometry and material description
5     #
6     # G. Ward
7     #
8     use strict;
9 greg 2.13 use File::Temp qw/ :mktemp /;
10 greg 2.1 sub userror {
11 greg 2.15 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 greg 2.1 exit 1;
13     }
14 greg 2.13 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 greg 2.1 chomp $td;
16 greg 2.20 my @savedARGV = @ARGV;
17 greg 2.15 my $tensortree = 0;
18     my $ttlog2 = 4;
19 greg 2.1 my $nsamp = 1000;
20 greg 2.10 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21 greg 2.1 my $mgfin = 0;
22     my $geout = 1;
23     my $nproc = 1;
24 greg 2.9 my $doforw = 0;
25     my $doback = 1;
26 greg 2.1 my @dim;
27     # Get options
28     while ($#ARGV >= 0) {
29     if ("$ARGV[0]" =~ /^[-+]m/) {
30     $mgfin = ("$ARGV[0]" =~ /^\+/);
31 greg 2.10 } elsif ("$ARGV[0]" eq "-r") {
32     $rtargs = "$rtargs $ARGV[1]";
33     shift @ARGV;
34 greg 2.1 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
35     $geout = ("$ARGV[0]" =~ /^\+/);
36 greg 2.9 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
37     $doforw = ("$ARGV[0]" =~ /^\+/);
38     } elsif ("$ARGV[0]" =~ /^[-+]b/) {
39     $doback = ("$ARGV[0]" =~ /^\+/);
40 greg 2.15 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
41     $tensortree = substr($ARGV[0], 2, 1);
42     $ttlog2 = $ARGV[1];
43     shift @ARGV;
44 greg 2.1 } elsif ("$ARGV[0]" eq "-c") {
45     $nsamp = $ARGV[1];
46     shift @ARGV;
47     } elsif ("$ARGV[0]" eq "-n") {
48     $nproc = $ARGV[1];
49     shift @ARGV;
50     } elsif ("$ARGV[0]" =~ /^-d/) {
51     userror() if ($#ARGV < 6);
52 greg 2.8 @dim = @ARGV[1..6];
53 greg 2.1 shift @ARGV for (1..6);
54     } elsif ("$ARGV[0]" =~ /^[-+]./) {
55     userror();
56     } else {
57     last;
58     }
59     shift @ARGV;
60     }
61 greg 2.9 # Check that we're actually being asked to do something
62 greg 2.15 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
63     # Name our own persist file?
64     my $persistfile;
65     if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
66     $persistfile = "$td/pfile.txt";
67     $rtargs = "-PP $persistfile $rtargs";
68     }
69 greg 2.1 # Get scene description and dimensions
70     my $radscn = "$td/device.rad";
71     my $mgfscn = "$td/device.mgf";
72     my $octree = "$td/device.oct";
73     if ( $mgfin ) {
74     system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
75     die "Could not load MGF input\n" if ( $? );
76     system "mgf2rad $mgfscn > $radscn";
77     } else {
78 greg 2.13 system "xform -e @ARGV > $radscn";
79 greg 2.1 die "Could not load Radiance input\n" if ( $? );
80     system "rad2mgf $radscn > $mgfscn" if ( $geout );
81     }
82     if ($#dim != 5) {
83 greg 2.7 @dim = split ' ', `getbbox -h $radscn`;
84 greg 2.1 }
85     print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
86 greg 2.9 # Add receiver surfaces (rectangular)
87 greg 2.10 my $fmodnm="receiver_face";
88 greg 2.9 my $bmodnm="receiver_behind";
89 greg 2.1 open(RADSCN, ">> $radscn");
90 greg 2.10 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
91     print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
92     print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
93     print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
94 greg 2.1 close RADSCN;
95     # Generate octree
96     system "oconv -w $radscn > $octree";
97     die "Could not compile scene\n" if ( $? );
98 greg 2.15 # Output XML prologue
99     print
100     '<?xml version="1.0" encoding="UTF-8"?>
101     <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
102 greg 2.20 ';
103     print "<!-- File produced by: genBSDF @savedARGV -->\n";
104     print
105     '<WindowElementType>System</WindowElementType>
106 greg 2.15 <Optical>
107     <Layer>
108     <Material>
109     <Name>Name</Name>
110     <Manufacturer>Manufacturer</Manufacturer>
111     ';
112     printf "\t\t<Thickness unit=\"Meter\">%.3f</Thickness>\n", $dim[5] - $dim[4];
113     printf "\t\t<Width unit=\"Meter\">%.3f</Width>\n", $dim[1] - $dim[0];
114     printf "\t\t<Height unit=\"Meter\">%.3f</Height>\n", $dim[3] - $dim[2];
115     print "\t\t<DeviceType>Integral</DeviceType>\n";
116     # Output MGF description if requested
117     if ( $geout ) {
118     print "\t\t<Geometry format=\"MGF\" unit=\"Meter\">\n";
119     printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
120     open(MGFSCN, "< $mgfscn");
121     while (<MGFSCN>) { print $_; }
122     close MGFSCN;
123     print "xf\n";
124     print "\t\t</Geometry>\n";
125     }
126     print " </Material>\n";
127     # Set up surface sampling
128     my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
129     my $ny = int($nsamp/$nx + .5);
130     $nsamp = $nx * $ny;
131     my $ns = 2**$ttlog2;
132     my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
133     # Create data segments (all the work happens here)
134     if ( $tensortree ) {
135     do_tree_bsdf();
136     } else {
137     do_matrix_bsdf();
138     }
139     # Output XML epilogue
140     print
141     '</Layer>
142     </Optical>
143     </WindowElement>
144     ';
145     # Clean up temporary files and exit
146 greg 2.16 if ( $persistfile && open(PFI, "< $persistfile") ) {
147 greg 2.15 while (<PFI>) {
148     s/^[^ ]* //;
149     kill('ALRM', $_);
150     last;
151     }
152     close PFI;
153     }
154 greg 2.16 exec("rm -rf $td");
155    
156 greg 2.15 #-------------- End of main program segment --------------#
157    
158     #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
159     sub do_tree_bsdf {
160     # Get sampling rate and subdivide task
161     my $ns2 = $ns;
162     $ns2 /= 2 if ( $tensortree == 3 );
163     @pdiv = (0, int($ns2/$nproc));
164     my $nrem = $ns2 % $nproc;
165     for (my $i = 1; $i < $nproc; $i++) {
166     my $nv = $pdiv[$i] + $pdiv[1];
167     ++$nv if ( $nrem-- > 0 );
168     push @pdiv, $nv;
169     }
170     die "Script error 1" if ($pdiv[-1] != $ns2);
171     # Shirley-Chiu mapping from unit square to disk
172     $sq2disk = '
173     in_square_a = 2*in_square_x - 1;
174     in_square_b = 2*in_square_y - 1;
175     in_square_rgn = if(in_square_a + in_square_b,
176     if(in_square_a - in_square_b, 1, 2),
177     if(in_square_b - in_square_a, 3, 4));
178     out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
179     -in_square_a, -in_square_b);
180     out_disk_phi = PI/4 * select(in_square_rgn,
181     in_square_b/in_square_a,
182     2 - in_square_a/in_square_b,
183     4 + in_square_b/in_square_a,
184     if(in_square_b*in_square_b,
185     6 - in_square_a/in_square_b, 0));
186     Dx = out_disk_r*cos(out_disk_phi);
187     Dy = out_disk_r*sin(out_disk_phi);
188     Dz = sqrt(1 - out_disk_r*out_disk_r);
189     ';
190     # Shirley-Chiu mapping from unit disk to square
191     $disk2sq = '
192     norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
193     in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
194     in_disk_phi = norm_radians(atan2(Dy, Dx));
195     in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
196     out_square_a = select(in_disk_rgn,
197     in_disk_r,
198     (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
199     -in_disk_r,
200     (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
201     out_square_b = select(in_disk_rgn,
202     in_disk_phi*in_disk_r/(PI/4),
203     in_disk_r,
204     (PI - in_disk_phi)*in_disk_r/(PI/4),
205     -in_disk_r);
206     out_square_x = (out_square_a + 1)/2;
207     out_square_y = (out_square_b + 1)/2;
208     ';
209     # Announce ourselves in XML output
210 greg 2.16 print "\t<DataDefinition>\n";
211     print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
212     print "\t</DataDefinition>\n";
213 greg 2.15 # Fork parallel rtcontrib processes to compute each side
214     if ( $doback ) {
215     for (my $proc = 0; $proc < $nproc; $proc++) {
216     bg_tree_rtcontrib(0, $proc);
217     }
218     while (wait() >= 0) {
219     die "rtcontrib process reported error" if ( $? );
220     }
221     ttree_out(0);
222     }
223     if ( $doforw ) {
224     for (my $proc = 0; $proc < $nproc; $proc++) {
225     bg_tree_rtcontrib(1, $proc);
226     }
227     while (wait() >= 0) {
228     die "rtcontrib process reported error" if ( $? );
229     }
230     ttree_out(1);
231     }
232     } # end of sub do_tree_bsdf()
233    
234     # Run i'th rtcontrib process for generating tensor tree samples
235     sub bg_tree_rtcontrib {
236     my $pid = fork();
237     die "Cannot fork new process" unless defined $pid;
238     if ($pid > 0) { return $pid; }
239     my $forw = shift;
240     my $pn = shift;
241     my $pbeg = $pdiv[$pn];
242     my $plen = $pdiv[$pn+1] - $pbeg;
243     my $matargs = "-m $bmodnm";
244     if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
245     my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
246     "-e '$disk2sq' -bn '$ns*$ns' " .
247     "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
248     "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
249     if ( $tensortree == 3 ) {
250     # Isotropic BSDF
251     $cmd = "cnt $plen $ny $nx " .
252     "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
253     "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
254     "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
255 greg 2.18 "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
256 greg 2.15 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
257     "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
258     "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
259     "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
260     "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
261     "| $cmd";
262     } else {
263     # Anisotropic BSDF
264     # Sample area vertically to improve load balance, since
265     # shading systems usually have bilateral symmetry (L-R)
266     $cmd = "cnt $plen $ns $ny $nx " .
267     "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
268     "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
269     "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
270     "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
271     "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
272     "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
273     "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
274     "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
275     "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
276     "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
277     "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
278     "| $cmd";
279     }
280     # print STDERR "Starting: $cmd\n";
281     exec($cmd); # no return; status report to parent via wait
282     die "Cannot exec: $cmd\n";
283     } # end of bg_tree_rtcontrib()
284    
285     # Simplify and output tensor tree results
286     sub ttree_out {
287     my $forw = shift;
288     my $side = ("Back","Front")[$forw];
289     # Only output one transmitted distribution, preferring backwards
290     if ( !$forw || !$doback ) {
291     print
292     ' <WavelengthData>
293     <LayerNumber>System</LayerNumber>
294     <Wavelength unit="Integral">Visible</Wavelength>
295     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
296     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
297     <WavelengthDataBlock>
298     <WavelengthDataDirection>Transmission</WavelengthDataDirection>
299     <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
300     <ScatteringDataType>BTDF</ScatteringDataType>
301     <ScatteringData>
302     ';
303     system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
304     q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
305     "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
306     "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
307     die "Failure running rttree_reduce" if ( $? );
308     print
309     ' </ScatteringData>
310     </WavelengthDataBlock>
311     </WavelengthData>
312     ';
313     }
314     # Output reflection
315     print
316     ' <WavelengthData>
317     <LayerNumber>System</LayerNumber>
318     <Wavelength unit="Integral">Visible</Wavelength>
319     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
320     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
321     <WavelengthDataBlock>
322 greg 2.17 ';
323     print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
324 greg 2.20 print
325     ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
326 greg 2.15 <ScatteringDataType>BRDF</ScatteringDataType>
327     <ScatteringData>
328     ';
329     system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
330     q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
331     "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
332     "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
333     die "Failure running rttree_reduce" if ( $? );
334     print
335     ' </ScatteringData>
336     </WavelengthDataBlock>
337     </WavelengthData>
338     ';
339     } # end of ttree_out()
340    
341     #------------- End of do_tree_bsdf() & subroutines -------------#
342    
343     #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
344     sub do_matrix_bsdf {
345     # Set up sampling of portal
346 greg 2.1 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
347 greg 2.15 $tcal = '
348 greg 2.1 DEGREE : PI/180;
349 greg 2.5 sq(x) : x*x;
350 greg 2.1 Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
351     Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
352     Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
353     Kmax : Kaccum(Knaz(0));
354     Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
355     Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
356     Kcol = Kbin - Kaccum(Krow-1);
357 greg 2.2 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
358 greg 2.1 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
359     sin_kpol = sin(Kpol);
360 greg 2.9 Dx = cos(Kazi)*sin_kpol;
361 greg 2.1 Dy = sin(Kazi)*sin_kpol;
362     Dz = sqrt(1 - sin_kpol*sin_kpol);
363 greg 2.5 KprojOmega = PI * if(Kbin-.5,
364     (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
365     1 - sq(cos(Kpola(1)*DEGREE)));
366 greg 2.1 ';
367 greg 2.9 # Compute Klems bin from exiting ray direction (forward or backward)
368 greg 2.15 $kcal = '
369 greg 2.1 DEGREE : PI/180;
370 greg 2.11 abs(x) : if(x, x, -x);
371 greg 2.1 Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
372     posangle(a) : if(-a, a + 2*PI, a);
373     Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
374     kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
375     knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
376     kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
377     kfindrow(r, pol) : if(r-kpola(0)+.5, r,
378     if(pol-kpola(r), kfindrow(r+1, pol), r) );
379     kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
380     kbin2(pol,azi) = select(kfindrow(1, pol),
381     kazn(azi,360/knaz(1)),
382     kaccum(1) + kazn(azi,360/knaz(2)),
383     kaccum(2) + kazn(azi,360/knaz(3)),
384     kaccum(3) + kazn(azi,360/knaz(4)),
385     kaccum(4) + kazn(azi,360/knaz(5)),
386     kaccum(5) + kazn(azi,360/knaz(6)),
387     kaccum(6) + kazn(azi,360/knaz(7)),
388     kaccum(7) + kazn(azi,360/knaz(8)),
389     kaccum(8) + kazn(azi,360/knaz(9))
390     );
391 greg 2.11 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
392 greg 2.1 ';
393     my $ndiv = 145;
394 greg 2.3 # Compute scattering data using rtcontrib
395 greg 2.9 my @tfarr;
396     my @rfarr;
397     my @tbarr;
398     my @rbarr;
399     my $cmd;
400 greg 2.15 my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
401 greg 2.9 "-e '$kcal' -b kbin -bn $ndiv " .
402 greg 2.15 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
403 greg 2.9 my $rccmd = "rcalc -e '$tcal' " .
404     "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
405     q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega'};
406     if ( $doforw ) {
407     $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
408 greg 2.11 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
409     "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
410 greg 2.10 "-e 'zp:$dim[4]' " .
411 greg 2.11 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
412 greg 2.10 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
413 greg 2.9 "| $rtcmd";
414     system "$cmd" || die "Failure running: $cmd\n";
415     @tfarr = `$rccmd $td/$fmodnm.flt`;
416     die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
417     @rfarr = `$rccmd $td/$bmodnm.flt`;
418     die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
419     }
420     if ( $doback ) {
421     $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
422     "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
423     "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
424 greg 2.10 "-e 'zp:$dim[5]' " .
425 greg 2.9 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
426 greg 2.11 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
427 greg 2.9 "| $rtcmd";
428     system "$cmd" || die "Failure running: $cmd\n";
429     @tbarr = `$rccmd $td/$bmodnm.flt`;
430     die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
431     @rbarr = `$rccmd $td/$fmodnm.flt`;
432     die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
433     }
434 greg 2.15 # Output angle basis
435 greg 2.1 print
436 greg 2.15 ' <DataDefinition>
437     <IncidentDataStructure>Columns</IncidentDataStructure>
438     <AngleBasis>
439 greg 2.1 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
440 greg 2.15 <AngleBasisBlock>
441 greg 2.1 <Theta>0</Theta>
442     <nPhis>1</nPhis>
443     <ThetaBounds>
444 greg 2.15 <LowerTheta>0</LowerTheta>
445     <UpperTheta>5</UpperTheta>
446 greg 2.1 </ThetaBounds>
447     </AngleBasisBlock>
448     <AngleBasisBlock>
449     <Theta>10</Theta>
450     <nPhis>8</nPhis>
451     <ThetaBounds>
452     <LowerTheta>5</LowerTheta>
453     <UpperTheta>15</UpperTheta>
454     </ThetaBounds>
455     </AngleBasisBlock>
456     <AngleBasisBlock>
457     <Theta>20</Theta>
458     <nPhis>16</nPhis>
459     <ThetaBounds>
460     <LowerTheta>15</LowerTheta>
461     <UpperTheta>25</UpperTheta>
462     </ThetaBounds>
463     </AngleBasisBlock>
464     <AngleBasisBlock>
465     <Theta>30</Theta>
466     <nPhis>20</nPhis>
467     <ThetaBounds>
468     <LowerTheta>25</LowerTheta>
469     <UpperTheta>35</UpperTheta>
470     </ThetaBounds>
471     </AngleBasisBlock>
472     <AngleBasisBlock>
473     <Theta>40</Theta>
474     <nPhis>24</nPhis>
475     <ThetaBounds>
476     <LowerTheta>35</LowerTheta>
477     <UpperTheta>45</UpperTheta>
478     </ThetaBounds>
479     </AngleBasisBlock>
480     <AngleBasisBlock>
481     <Theta>50</Theta>
482     <nPhis>24</nPhis>
483     <ThetaBounds>
484     <LowerTheta>45</LowerTheta>
485     <UpperTheta>55</UpperTheta>
486     </ThetaBounds>
487     </AngleBasisBlock>
488     <AngleBasisBlock>
489     <Theta>60</Theta>
490     <nPhis>24</nPhis>
491     <ThetaBounds>
492     <LowerTheta>55</LowerTheta>
493     <UpperTheta>65</UpperTheta>
494     </ThetaBounds>
495     </AngleBasisBlock>
496     <AngleBasisBlock>
497     <Theta>70</Theta>
498     <nPhis>16</nPhis>
499     <ThetaBounds>
500     <LowerTheta>65</LowerTheta>
501     <UpperTheta>75</UpperTheta>
502     </ThetaBounds>
503     </AngleBasisBlock>
504     <AngleBasisBlock>
505     <Theta>82.5</Theta>
506     <nPhis>12</nPhis>
507     <ThetaBounds>
508     <LowerTheta>75</LowerTheta>
509     <UpperTheta>90</UpperTheta>
510     </ThetaBounds>
511     </AngleBasisBlock>
512     </AngleBasis>
513     </DataDefinition>
514 greg 2.9 ';
515     if ( $doforw ) {
516 greg 2.15 print
517     ' <WavelengthData>
518 greg 2.9 <LayerNumber>System</LayerNumber>
519     <Wavelength unit="Integral">Visible</Wavelength>
520     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
521     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
522     <WavelengthDataBlock>
523     <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
524     <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
525     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
526     <ScatteringDataType>BTDF</ScatteringDataType>
527     <ScatteringData>
528     ';
529     # Output front transmission (transposed order)
530     for (my $od = 0; $od < $ndiv; $od++) {
531     for (my $id = 0; $id < $ndiv; $id++) {
532     print $tfarr[$ndiv*$id + $od];
533     }
534     print "\n";
535     }
536     print
537 greg 2.15 ' </ScatteringData>
538     </WavelengthDataBlock>
539 greg 2.9 </WavelengthData>
540 greg 2.1 <WavelengthData>
541     <LayerNumber>System</LayerNumber>
542     <Wavelength unit="Integral">Visible</Wavelength>
543     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
544     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
545     <WavelengthDataBlock>
546 greg 2.9 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
547     <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
548     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
549     <ScatteringDataType>BRDF</ScatteringDataType>
550     <ScatteringData>
551     ';
552     # Output front reflection (transposed order)
553     for (my $od = 0; $od < $ndiv; $od++) {
554     for (my $id = 0; $id < $ndiv; $id++) {
555     print $rfarr[$ndiv*$id + $od];
556     }
557     print "\n";
558     }
559     print
560 greg 2.15 ' </ScatteringData>
561     </WavelengthDataBlock>
562 greg 2.9 </WavelengthData>
563     ';
564     }
565     if ( $doback ) {
566 greg 2.15 print
567     ' <WavelengthData>
568 greg 2.9 <LayerNumber>System</LayerNumber>
569     <Wavelength unit="Integral">Visible</Wavelength>
570     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
571     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
572     <WavelengthDataBlock>
573     <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
574 greg 2.1 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
575     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
576     <ScatteringDataType>BTDF</ScatteringDataType>
577     <ScatteringData>
578     ';
579 greg 2.9 # Output back transmission (transposed order)
580 greg 2.3 for (my $od = 0; $od < $ndiv; $od++) {
581     for (my $id = 0; $id < $ndiv; $id++) {
582 greg 2.9 print $tbarr[$ndiv*$id + $od];
583     }
584     print "\n";
585     }
586     print
587 greg 2.15 ' </ScatteringData>
588     </WavelengthDataBlock>
589 greg 2.9 </WavelengthData>
590     <WavelengthData>
591     <LayerNumber>System</LayerNumber>
592     <Wavelength unit="Integral">Visible</Wavelength>
593     <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
594     <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
595     <WavelengthDataBlock>
596     <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
597     <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
598     <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
599     <ScatteringDataType>BRDF</ScatteringDataType>
600     <ScatteringData>
601     ';
602     # Output back reflection (transposed order)
603     for (my $od = 0; $od < $ndiv; $od++) {
604     for (my $id = 0; $id < $ndiv; $id++) {
605     print $rbarr[$ndiv*$id + $od];
606 greg 2.3 }
607     print "\n";
608     }
609 greg 2.1 print
610 greg 2.15 ' </ScatteringData>
611     </WavelengthDataBlock>
612 greg 2.1 </WavelengthData>
613 greg 2.9 ';
614     }
615 greg 2.15 }
616     #------------- End of do_matrix_bsdf() --------------#